/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreLabelRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreLabel extends TableImpl<VCoreLabelRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_label</code>
     */
    public static final VCoreLabel V_CORE_LABEL = new VCoreLabel();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreLabelRecord> getRecordType() {
        return VCoreLabelRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_label.unique_name</code>.
     */
    public final TableField<VCoreLabelRecord, String> UNIQUE_NAME = createField(DSL.name("unique_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_label.de_de</code>.
     */
    public final TableField<VCoreLabelRecord, String> DE_DE = createField(DSL.name("de_de"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_label.en</code>.
     */
    public final TableField<VCoreLabelRecord, String> EN = createField(DSL.name("en"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_label.pl</code>.
     */
    public final TableField<VCoreLabelRecord, String> PL = createField(DSL.name("pl"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_label.pt_br</code>.
     */
    public final TableField<VCoreLabelRecord, String> PT_BR = createField(DSL.name("pt_br"), SQLDataType.CLOB, this, "");

    private VCoreLabel(Name alias, Table<VCoreLabelRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreLabel(Name alias, Table<VCoreLabelRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_label" as  SELECT COALESCE(h.unique_name, h.dn) AS unique_name,
         COALESCE(l1.value, l2.value, l3.value, l4.value, h.unique_name, h.dn, h.short_name) AS de_de,
         COALESCE(l5.value, l6.value, l7.value, l8.value, h.unique_name, h.dn, h.short_name) AS en,
         COALESCE(l9.value, l10.value, l11.value, l12.value, h.unique_name, h.dn, h.short_name) AS pl,
         COALESCE(l13.value, l14.value, l15.value, l16.value, h.unique_name, h.dn, h.short_name) AS pt_br
        FROM ((((((((((((((((common_dd.t_core_element_hierarchy h
          LEFT JOIN common_dd.t_core_translation l1 ON (((l1.fk_trans_key = h.hier_lang) AND (l1.isocode = 'de_DE'::common_dd.enum_isocode) AND (l1.category = 'short'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation l2 ON (((l2.fk_trans_key = h.hier_lang) AND (l2.isocode = 'de_DE'::common_dd.enum_isocode) AND (l2.category = 'long'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation l3 ON (((l3.fk_trans_key = h.hier_lang) AND (l3.isocode = 'de_DE'::common_dd.enum_isocode) AND (l3.category = 'crf'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation l4 ON (((l4.fk_trans_key = h.hier_lang) AND (l4.isocode = 'de_DE'::common_dd.enum_isocode) AND (l4.category = 'full'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation l5 ON (((l5.fk_trans_key = h.hier_lang) AND (l5.isocode = 'en'::common_dd.enum_isocode) AND (l5.category = 'short'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation l6 ON (((l6.fk_trans_key = h.hier_lang) AND (l6.isocode = 'en'::common_dd.enum_isocode) AND (l6.category = 'long'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation l7 ON (((l7.fk_trans_key = h.hier_lang) AND (l7.isocode = 'en'::common_dd.enum_isocode) AND (l7.category = 'crf'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation l8 ON (((l8.fk_trans_key = h.hier_lang) AND (l8.isocode = 'en'::common_dd.enum_isocode) AND (l8.category = 'full'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation l9 ON (((l9.fk_trans_key = h.hier_lang) AND (l9.isocode = 'pl'::common_dd.enum_isocode) AND (l9.category = 'short'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation l10 ON (((l10.fk_trans_key = h.hier_lang) AND (l10.isocode = 'pl'::common_dd.enum_isocode) AND (l10.category = 'long'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation l11 ON (((l11.fk_trans_key = h.hier_lang) AND (l11.isocode = 'pl'::common_dd.enum_isocode) AND (l11.category = 'crf'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation l12 ON (((l12.fk_trans_key = h.hier_lang) AND (l12.isocode = 'pl'::common_dd.enum_isocode) AND (l12.category = 'full'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation l13 ON (((l13.fk_trans_key = h.hier_lang) AND (l13.isocode = 'pt_BR'::common_dd.enum_isocode) AND (l13.category = 'short'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation l14 ON (((l14.fk_trans_key = h.hier_lang) AND (l14.isocode = 'pt_BR'::common_dd.enum_isocode) AND (l14.category = 'long'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation l15 ON (((l15.fk_trans_key = h.hier_lang) AND (l15.isocode = 'pt_BR'::common_dd.enum_isocode) AND (l15.category = 'crf'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation l16 ON (((l16.fk_trans_key = h.hier_lang) AND (l16.isocode = 'pt_BR'::common_dd.enum_isocode) AND (l16.category = 'full'::common_dd.enum_trans_category))));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_label</code> table reference
     */
    public VCoreLabel(String alias) {
        this(DSL.name(alias), V_CORE_LABEL);
    }

    /**
     * Create an aliased <code>common_dd.v_core_label</code> table reference
     */
    public VCoreLabel(Name alias) {
        this(alias, V_CORE_LABEL);
    }

    /**
     * Create a <code>common_dd.v_core_label</code> table reference
     */
    public VCoreLabel() {
        this(DSL.name("v_core_label"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreLabel as(String alias) {
        return new VCoreLabel(DSL.name(alias), this);
    }

    @Override
    public VCoreLabel as(Name alias) {
        return new VCoreLabel(alias, this);
    }

    @Override
    public VCoreLabel as(Table<?> alias) {
        return new VCoreLabel(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreLabel rename(String name) {
        return new VCoreLabel(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreLabel rename(Name name) {
        return new VCoreLabel(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreLabel rename(Table<?> name) {
        return new VCoreLabel(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLabel where(Condition condition) {
        return new VCoreLabel(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLabel where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLabel where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLabel where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLabel where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLabel where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLabel where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLabel where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLabel whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLabel whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
